/*
showprinters.c: Lists all available printers
Copyright (C) 2005 Revolution Linux inc, Jean-Michel Dault
	      jmdault@revolutionlinux.com

Originally from Michael Kaply (IBM) (mkaply) <mozilla@kaply.com>
https://bugzilla.mozilla.org/show_bug.cgi?id=251754
The patch was included in Mozilla to add support for cups.
We use the same code to test libhideprinters.so with Mozilla.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <link.h>
#include <cups/http.h>
#include <cups/ipp.h>
#include <cups/cups.h>

int main()
{
  int  num_dests;
  cups_dest_t      *dests;
  
  num_dests = cupsGetDests(&dests);
  printf("Printers found: %d\n",num_dests);
  
  if (num_dests > 0) 
  {
    int i;
    cups_dest_t      *defdest;
  
    defdest = cupsGetDest(NULL, NULL, num_dests, dests);
    printf("Printer:\t%s\t\t[Default]\n",defdest->name);
  
    for (i = 0; i < num_dests; i ++) 
    {
      if (strcmp(dests[i].name, defdest->name) != 0)
        printf("Printer:\t%s\n",dests[i].name);
    }
    cupsFreeDests(num_dests,dests);

  }
  return 0;
}
